#!/usr/bin/python

import smbus 
import time

class MyKeyboard:

    KeyPadTable= [['1','4','7','*'], ['2','5','8','0'],
                  ['3','6','9','#'], ['A','B','C','D']]
    RowID=[0,0,0,0,0,0,0,4,0,0,0,3,0,2,1,0]
    CurrentKey=None

    def __init__(self, I2CBus=1, I2CAddress=0x20):
        self.I2CAddress = I2CAddress
        self.I2CBus = I2CBus
            #open smbus pcf8574
        self.bus = smbus.SMBus(self.I2CBus)
            #set pcf to input
        self.bus.write_byte(self.I2CAddress,0xff)

    #ReadRawKey - this function will scan and return a key press with no debouncing.
    # it will return None if no or more than a key is pressed on the same row
    def ReadRawKey(self):
    #set P4 Low First
        OutPin= 0x10
        for Column in range(4):  
      #scan first row to see if we have something
            self.bus.write_byte(self.I2CAddress,~OutPin)
      #read the key now 
            key = self.RowID[self.bus.read_byte(self.I2CAddress) & 0x0f]
            if key > 0:
                return self.KeyPadTable[key-1][Column]
            OutPin = OutPin * 2
        return None

       #ReadKey return current key once and debounce it
    def ReadKey(self):
        LastKey= self.CurrentKey;
        while True:
            NewKey= self.ReadRawKey()
            if  NewKey != LastKey:
                time.sleep(0.01)
                LastKey= NewKey
            else:
                break
          #if LastValue is the same than CurrentValue just return None
        if LastKey==self.CurrentKey:
            return None
          #ok put Lastvalue to be CurrentValue
        self.CurrentKey=LastKey
        return self.CurrentKey
